igeo

## Class ISpringLine

- java.lang.Object
- - igeo.IObject
  - - igeo.IGeometry
    - - igeo.ICurve
      - - igeo.ISpringLine

- All Implemented Interfaces:
    ICurveI, ICurveOp, IDynamics, IParameter, ISpringI, ISubobject, ITensionI, ITransformable, IVal

      public class ISpringLine
      extends ICurve
      implements ISpringI, IDynamics

  Class of IDynamicObject to simulate spring force between two particles.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `ISpring` | `springDynamics`
    `java.util.ArrayList<IObject>` | `targets` target objects to be updated by dynamic object

    - ### Fields inherited from class igeo.ICurve

      `curve`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

    - ### Fields inherited from interface igeo.ITensionI

      `defaultTension`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ISpringLine(IParticleI p1, IParticleI p2)`
    `ISpringLine(IParticleI p1, IParticleI p2, double tension)`
    `ISpringLine(IParticleI p1, IParticleI p2, double tension, double length)`
    `ISpringLine(IVecI p1, IVecI p2)`
    `ISpringLine(IVecI p1, IVecI p2, double tension)`
    `ISpringLine(IVecI p1, IVecI p2, double tension, double length)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ISpringLine` | `attr(IAttribute at)` set attributes
    `ISpringLine` | `clr(java.awt.Color c)`
    `ISpringLine` | `clr(java.awt.Color c, double alpha)`
    `ISpringLine` | `clr(java.awt.Color c, float alpha)`
    `ISpringLine` | `clr(java.awt.Color c, int alpha)`
    `ISpringLine` | `clr(double dgray)`
    `ISpringLine` | `clr(double dgray, double dalpha)`
    `ISpringLine` | `clr(double dr, double dg, double db)`
    `ISpringLine` | `clr(double dr, double dg, double db, double da)`
    `ISpringLine` | `clr(float fgray)`
    `ISpringLine` | `clr(float fgray, float falpha)`
    `ISpringLine` | `clr(float fr, float fg, float fb)`
    `ISpringLine` | `clr(float fr, float fg, float fb, float fa)`
    `ISpringLine` | `clr(IColor c)` to set an object color
    `ISpringLine` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `ISpringLine` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `ISpringLine` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `ISpringLine` | `clr(int gray)`
    `ISpringLine` | `clr(int gray, int alpha)`
    `ISpringLine` | `clr(int r, int g, int b)`
    `ISpringLine` | `clr(int r, int g, int b, int a)`
    `ISpringLine` | `clr(IObject o)` to set the same color with the object
    `boolean` | `constant()` if constantTension is true, amount of force is always constant and it's equals to tension.
    `ISpringLine` | `constant(boolean cnst)` if constantTension is true, amount of force is always constant and it's equals to tension.
    `ISpringLine` | `hide()`
    `ISpringLine` | `hsb(double h, double s, double b)`
    `ISpringLine` | `hsb(double h, double s, double b, double a)`
    `ISpringLine` | `hsb(float h, float s, float b)`
    `ISpringLine` | `hsb(float h, float s, float b, float a)`
    `void` | `initSpringLine(IParticleI p1, IParticleI p2)`
    `void` | `initSpringLine(IParticleI p1, IParticleI p2, double tension)`
    `void` | `initSpringLine(IParticleI p1, IParticleI p2, double tension, double length)`
    `void` | `interact(java.util.ArrayList<IDynamics> dynamics)` behavior definition of interaction with other dynamic objects.
    `ISpringLine` | `layer(ILayer l)` Set layer by ILayer object
    `ISpringLine` | `layer(java.lang.String l)` Set layer by layer name.
    `double` | `len()` get length
    `ISpringLine` | `len(double length)` set length
    `ISpringLine` | `len(IVecI p1, IVecI p2)` set length by two points
    `double` | `length()` alias of len
    `ISpringLine` | `length(double length)` alias of len
    `ISpringLine` | `length(IVecI p1, IVecI p2)` alias of len
    `java.util.ArrayList<IDynamics>` | `localDynamics()` IDynamicsBase doesn't implement local dynamics feature
    `double` | `maxTension()` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension.
    `ISpringLine` | `maxTension(double maxTension)` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
    `ISpringLine` | `name(java.lang.String nm)` IObject methods
    `ISpringLine` | `parent()` for IDynamics
    `ISpringLine` | `parent(IObject par)` setting parent object
    `IParticleI` | `particle(int i)` alias of pt(int)
    `IParticleI` | `particle1()` alias of pt1()
    `IParticleI` | `particle2()` alias of pt2()
    `IVec` | `pos(int i)` position of particle(i)
    `IVec` | `pos1()` position of particle1
    `IVec` | `pos2()` position of particle2
    `void` | `postinteract(java.util.ArrayList<IDynamics> dynamics)` executed after interact(ArrayList).
    `void` | `postupdate()` executed after update().
    `void` | `preinteract(java.util.ArrayList<IDynamics> dynamics)` executed before interact(ArrayList).
    `void` | `preupdate()` executed before update().
    `IParticleI` | `pt(int i)` getting end point.
    `IParticleI` | `pt1()` getting end point1.
    `IParticleI` | `pt2()` getting end point2.
    `ISpringLine` | `removeTarget(int i)` remove target object.
    `ISpringLine` | `removeTarget(IObject obj)` remove target object.
    `ISpringLine` | `setColor(java.awt.Color c)`
    `ISpringLine` | `setColor(java.awt.Color c, double alpha)`
    `ISpringLine` | `setColor(java.awt.Color c, float alpha)`
    `ISpringLine` | `setColor(java.awt.Color c, int alpha)`
    `ISpringLine` | `setColor(double dgray)`
    `ISpringLine` | `setColor(double dgray, double dalpha)`
    `ISpringLine` | `setColor(double dr, double dg, double db)`
    `ISpringLine` | `setColor(double dr, double dg, double db, double da)`
    `ISpringLine` | `setColor(float fgray)`
    `ISpringLine` | `setColor(float fgray, float falpha)`
    `ISpringLine` | `setColor(float fr, float fg, float fb)`
    `ISpringLine` | `setColor(float fr, float fg, float fb, float fa)`
    `ISpringLine` | `setColor(IColor c)`
    `ISpringLine` | `setColor(IColor c, double alpha)`
    `ISpringLine` | `setColor(IColor c, float alpha)`
    `ISpringLine` | `setColor(IColor c, int alpha)`
    `ISpringLine` | `setColor(int gray)`
    `ISpringLine` | `setColor(int gray, int alpha)`
    `ISpringLine` | `setColor(int r, int g, int b)`
    `ISpringLine` | `setColor(int r, int g, int b, int a)`
    `ISpringLine` | `setHSBColor(double h, double s, double b)`
    `ISpringLine` | `setHSBColor(double h, double s, double b, double a)`
    `ISpringLine` | `setHSBColor(float h, float s, float b)`
    `ISpringLine` | `setHSBColor(float h, float s, float b, float a)`
    `ISpringLine` | `show()`
    `IObject` | `target(int i)` get target object.
    `ISpringLine` | `target(IObject targetObj)` add terget object to be updated by this dynamic object.
    `int` | `targetNum()` get total target number.
    `java.util.ArrayList<IObject>` | `targets()` get all target objects.
    `double` | `tension()` tension is a coefficient to convert distance of two points to amount of force.
    `ISpringLine` | `tension(double tensionIntensity)` tension is a coefficient to convert distance of two points to amount of force.
    `void` | `update()` behavior definition of updating dynamics in each time frame
    `void` | `updateTarget()` update all terget objects (should be called when the dynamic object is updated).
    `ISpringLine` | `weight(double w)`
    `ISpringLine` | `weight(float w)`

    - ### Methods inherited from class igeo.ICurve

      `add, add, add, add, add, add, add, addCP, addCP, addCP, addCP, addCP, addCP, addCP, addCP, center, closePt, closePt, cp, cp, cp, cp, cp, cp, cpNum, cpNum, cpNum, cps, createGraphic, deg, deg, deg, dist, dist, div, div, dup, end, endCP, ep, ep, epNum, epNum, epNum, flip, flipU, get, initCurve, insertCP, insertCP, intersectPlane, intersectPlane, isClosed, isClosed, isClosed, isInside2d, isInside2d, isRational, isRational, isRational, isValid, knot, knot, knotNum, knotNum, knotNum, knots, knots, knots, len, len, mid, mirror, mirror, mul, mul, mv, mv, mv, neg, num, num, num, pt, pt, ref, ref, removeCP, removeCP, removeCP, rev, revU, rot, rot, rot, rot, rot, rot, rot, rot, rot2, rot2, rot2, rot2, rot2, rot2, scale, scale, scale, scale, scale1d, scale1d, scale1d, scale1d, shear, shear, shear, shear, shearXY, shearXY, shearXY, shearXY, shearYZ, shearYZ, shearYZ, shearYZ, shearZX, shearZX, shearZX, shearZX, start, startCP, sub, sub, sub, tan, tan, transform, transform, transform, transform, translate, translate, translate, u, u, u, u, u, u, u, u, uend, uend, uend, ustart, ustart, ustart`

    - ### Methods inherited from class igeo.IObject

      `addDynamics, addUserData, addUserData, alpha, alphaInt, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isVisible, layer, name, red, redInt, resetGraphic, saturation, server, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, updateGraphic, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### springDynamics

          public ISpring springDynamics

    - #### targets

          public java.util.ArrayList<IObject> targets

      target objects to be updated by dynamic object

  - ### Constructor Detail

    - #### ISpringLine

          public ISpringLine(IParticleI p1,
                     IParticleI p2)

    - #### ISpringLine

          public ISpringLine(IParticleI p1,
                     IParticleI p2,
                     double tension)

    - #### ISpringLine

          public ISpringLine(IParticleI p1,
                     IParticleI p2,
                     double tension,
                     double length)

    - #### ISpringLine

          public ISpringLine(IVecI p1,
                     IVecI p2)

    - #### ISpringLine

          public ISpringLine(IVecI p1,
                     IVecI p2,
                     double tension)

    - #### ISpringLine

          public ISpringLine(IVecI p1,
                     IVecI p2,
                     double tension,
                     double length)

  - ### Method Detail

    - #### initSpringLine

          public void initSpringLine(IParticleI p1,
                            IParticleI p2)

    - #### initSpringLine

          public void initSpringLine(IParticleI p1,
                            IParticleI p2,
                            double tension)

    - #### initSpringLine

          public void initSpringLine(IParticleI p1,
                            IParticleI p2,
                            double tension,
                            double length)

    - #### tension

          public double tension()

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### tension

          public ISpringLine tension(double tensionIntensity)

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### constant

          public boolean constant()

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### constant

          public ISpringLine constant(boolean cnst)

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### maxTension

          public double maxTension()

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension. if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### maxTension

          public ISpringLine maxTension(double maxTension)

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### len

          public double len()

      Description copied from interface: `ISpringI`
      get length
      Specified by:
        `len` in interface `ICurveI`
      Specified by:
        `len` in interface `ISpringI`
      Overrides:
        `len` in class `ICurve`

    - #### len

          public ISpringLine len(double length)

      Description copied from interface: `ISpringI`
      set length
      Specified by:
        `len` in interface `ISpringI`

    - #### len

          public ISpringLine len(IVecI p1,
                        IVecI p2)

      Description copied from interface: `ISpringI`
      set length by two points
      Specified by:
        `len` in interface `ISpringI`

    - #### length

          public double length()

      Description copied from interface: `ISpringI`
      alias of len
      Specified by:
        `length` in interface `ISpringI`

    - #### length

          public ISpringLine length(double length)

      Description copied from interface: `ISpringI`
      alias of len
      Specified by:
        `length` in interface `ISpringI`

    - #### length

          public ISpringLine length(IVecI p1,
                           IVecI p2)

      Description copied from interface: `ISpringI`
      alias of len
      Specified by:
        `length` in interface `ISpringI`

    - #### pt

          public IParticleI pt(int i)

      getting end point. i==0 or i==1. if i is other value, returns first point.
      Specified by:
        `pt` in interface `ITensionI`

    - #### particle

          public IParticleI particle(int i)

      alias of pt(int)
      Specified by:
        `particle` in interface `ITensionI`

    - #### pos

          public IVec pos(int i)

      position of particle(i)
      Specified by:
        `pos` in interface `ITensionI`

    - #### pt1

          public IParticleI pt1()

      getting end point1.
      Specified by:
        `pt1` in interface `ITensionI`

    - #### particle1

          public IParticleI particle1()

      alias of pt1()
      Specified by:
        `particle1` in interface `ITensionI`

    - #### pos1

          public IVec pos1()

      position of particle1
      Specified by:
        `pos1` in interface `ITensionI`

    - #### pt2

          public IParticleI pt2()

      getting end point2.
      Specified by:
        `pt2` in interface `ITensionI`

    - #### particle2

          public IParticleI particle2()

      alias of pt2()
      Specified by:
        `particle2` in interface `ITensionI`

    - #### pos2

          public IVec pos2()

      position of particle2
      Specified by:
        `pos2` in interface `ITensionI`

    - #### parent

          public ISpringLine parent()

      for IDynamics
      Specified by:
        `parent` in interface `ISubobject`

    - #### parent

          public ISpringLine parent(IObject par)

      Description copied from interface: `ISubobject`
      setting parent object
      Specified by:
        `parent` in interface `ISubobject`

    - #### localDynamics

          public java.util.ArrayList<IDynamics> localDynamics()

      IDynamicsBase doesn't implement local dynamics feature
      Specified by:
        `localDynamics` in interface `IDynamics`

    - #### target

          public ISpringLine target(IObject targetObj)

      Description copied from interface: `IDynamics`
      add terget object to be updated by this dynamic object.
      Specified by:
        `target` in interface `IDynamics`

    - #### targetNum

          public int targetNum()

      get total target number.
      Specified by:
        `targetNum` in interface `IDynamics`

    - #### target

          public IObject target(int i)

      get target object.
      Specified by:
        `target` in interface `IDynamics`

    - #### targets

          public java.util.ArrayList<IObject> targets()

      get all target objects.
      Specified by:
        `targets` in interface `IDynamics`

    - #### removeTarget

          public ISpringLine removeTarget(int i)

      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`

    - #### removeTarget

          public ISpringLine removeTarget(IObject obj)

      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`

    - #### updateTarget

          public void updateTarget()

      update all terget objects (should be called when the dynamic object is updated).
      Specified by:
        `updateTarget` in interface `IDynamics`

    - #### interact

          public void interact(java.util.ArrayList<IDynamics> dynamics)

      behavior definition of interaction with other dynamic objects. The server puts all dynamic objects including itself.
      Specified by:
        `interact` in interface `IDynamics`

    - #### update

          public void update()

      behavior definition of updating dynamics in each time frame
      Specified by:
        `update` in interface `IDynamics`

    - #### preinteract

          public void preinteract(java.util.ArrayList<IDynamics> dynamics)

      Description copied from interface: `IDynamics`
      executed before interact(ArrayList). behavior can be changed by IConfig.enablePreinteract and IConfig.loopPreinteract.
      Specified by:
        `preinteract` in interface `IDynamics`

    - #### postinteract

          public void postinteract(java.util.ArrayList<IDynamics> dynamics)

      Description copied from interface: `IDynamics`
      executed after interact(ArrayList). behavior can be changed by IConfig.enablePostinteract and IConfig.loopPostinteract. If IConfig.loopPostinteract is false, preupdate is executed before post interact (updated 2012/08/26).
      Specified by:
        `postinteract` in interface `IDynamics`

    - #### preupdate

          public void preupdate()

      Description copied from interface: `IDynamics`
      executed before update(). behavior can be changed by IConfig.enablePreupdate and IConfig.loopPreupdate. If IConfig.loopPreupdate is false, preupdate is executed before post interact (updated 2012/08/26).
      Specified by:
        `preupdate` in interface `IDynamics`

    - #### postupdate

          public void postupdate()

      Description copied from interface: `IDynamics`
      executed after update(). behavior can be changed by IConfig.enablePostupdate and IConfig.loopPostupdate.
      Specified by:
        `postupdate` in interface `IDynamics`

    - #### name

          public ISpringLine name(java.lang.String nm)

      IObject methods
      Overrides:
        `name` in class `ICurve`

    - #### layer

          public ISpringLine layer(ILayer l)

      Description copied from class: `IGeometry`
      Set layer by ILayer object
      Overrides:
        `layer` in class `ICurve`

    - #### layer

          public ISpringLine layer(java.lang.String l)

      Description copied from class: `IGeometry`
      Set layer by layer name. If the layer specified by the name is not existing in the server, a new layer is automatically created in the server
      Overrides:
        `layer` in class `ICurve`

    - #### attr

          public ISpringLine attr(IAttribute at)

      Description copied from class: `IObject`
      set attributes
      Overrides:
        `attr` in class `ICurve`

    - #### hide

          public ISpringLine hide()

      Overrides:
        `hide` in class `ICurve`

    - #### show

          public ISpringLine show()

      Overrides:
        `show` in class `ICurve`

    - #### clr

          public ISpringLine clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(IColor c,
                        int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(IColor c,
                        float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(IColor c,
                        double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(java.awt.Color c)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(java.awt.Color c,
                        int alpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(java.awt.Color c,
                        float alpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(java.awt.Color c,
                        double alpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(int gray)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(float fgray)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(double dgray)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(int gray,
                        int alpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(float fgray,
                        float falpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(double dgray,
                        double dalpha)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(int r,
                        int g,
                        int b)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(float fr,
                        float fg,
                        float fb)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(double dr,
                        double dg,
                        double db)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(int r,
                        int g,
                        int b,
                        int a)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(float fr,
                        float fg,
                        float fb,
                        float fa)

      Overrides:
        `clr` in class `ICurve`

    - #### clr

          public ISpringLine clr(double dr,
                        double dg,
                        double db,
                        double da)

      Overrides:
        `clr` in class `ICurve`

    - #### hsb

          public ISpringLine hsb(float h,
                        float s,
                        float b,
                        float a)

      Overrides:
        `hsb` in class `ICurve`

    - #### hsb

          public ISpringLine hsb(double h,
                        double s,
                        double b,
                        double a)

      Overrides:
        `hsb` in class `ICurve`

    - #### hsb

          public ISpringLine hsb(float h,
                        float s,
                        float b)

      Overrides:
        `hsb` in class `ICurve`

    - #### hsb

          public ISpringLine hsb(double h,
                        double s,
                        double b)

      Overrides:
        `hsb` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(IColor c)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(IColor c,
                             int alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(IColor c,
                             float alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(IColor c,
                             double alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(java.awt.Color c)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(java.awt.Color c,
                             int alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(java.awt.Color c,
                             float alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(java.awt.Color c,
                             double alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(int gray)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(float fgray)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(double dgray)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(int gray,
                             int alpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(float fgray,
                             float falpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(double dgray,
                             double dalpha)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(int r,
                             int g,
                             int b)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(float fr,
                             float fg,
                             float fb)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(double dr,
                             double dg,
                             double db)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(int r,
                             int g,
                             int b,
                             int a)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(float fr,
                             float fg,
                             float fb,
                             float fa)

      Overrides:
        `setColor` in class `ICurve`

    - #### setColor

          public ISpringLine setColor(double dr,
                             double dg,
                             double db,
                             double da)

      Overrides:
        `setColor` in class `ICurve`

    - #### setHSBColor

          public ISpringLine setHSBColor(float h,
                                float s,
                                float b,
                                float a)

      Overrides:
        `setHSBColor` in class `ICurve`

    - #### setHSBColor

          public ISpringLine setHSBColor(double h,
                                double s,
                                double b,
                                double a)

      Overrides:
        `setHSBColor` in class `ICurve`

    - #### setHSBColor

          public ISpringLine setHSBColor(float h,
                                float s,
                                float b)

      Overrides:
        `setHSBColor` in class `ICurve`

    - #### setHSBColor

          public ISpringLine setHSBColor(double h,
                                double s,
                                double b)

      Overrides:
        `setHSBColor` in class `ICurve`

    - #### weight

          public ISpringLine weight(double w)

      Overrides:
        `weight` in class `ICurve`

    - #### weight

          public ISpringLine weight(float w)

      Overrides:
        `weight` in class `ICurve`